package com.dsic.gj_erp.controller.jcsj;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jcsj.DmTltpdf;
import com.dsic.gj_erp.bean.jcsj.excel.PlExcel;
import com.dsic.gj_erp.bean.jcsj.vo.BomVO;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.jcsj.DmBomService;
import com.dsic.gj_erp.service.jcsj.DmTltpdfService;
import com.dsic.gj_erp.service.jcsj.impl.BomUploadServiceImpl;
import com.dsic.gj_erp.service.sy.SYService;
import io.swagger.annotations.Authorization;
import org.apache.commons.lang3.StringUtils;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.text.PDFTextStripper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-25
 */
@RestController
@RequestMapping("/dmBom")
public class DmBomController {

    @Autowired
    DmBomService dmBomService;

    @Autowired
    BomUploadServiceImpl bomUploadService;
    @Autowired
    SYService syService;
    @Autowired
    DmTltpdfService tltpdfService;

    @PostMapping("/uploadPDF")
    @Authorization("")
    @ResponseBody
    public ResultBean uploadPDF(@RequestParam("file") MultipartFile file)throws IOException {
//        String pdfFilePath = "E:/runpeng/1润芃工作日志/第21个月/第3周/钢加项目资料/小池/B046HC103HN第046批量数控套料图2023-05-11.pdf"; // PDF文件路径
        PDDocument document = PDDocument.load(file.getInputStream());
        int pageNum = document.getNumberOfPages();
//
        PDFTextStripper stripper = new PDFTextStripper();
        stripper .setSortByPosition(true); //设置为true 则按照行进行读取，默认是false
//        // 指定页面读取内容
//        stripper.setStartPage(12); // 设置起始页面，这里设置成0，就表示读取第一个页面
//        stripper.setEndPage(12); // 设置结束页面，这里设置成0，就表示读取第一个页面
//        // 3、获取指定页面的文本内容
        stripper.setStartPage(2);
        stripper.setEndPage(2);
        String[] text = stripper.getText(document).split("\r\n")[2].split(" ");
        String dcCh=text[1];
        String th=text[10];
        List<DmTltpdf> list=new ArrayList<>();
        for (int i = 1; i <= pageNum; i++) {
            stripper.setStartPage(i);
            stripper.setEndPage(i);
            String s = stripper.getText(document);
            String[] a=s.split("\r\n");
//            System.out.println("第 " + i +"/"+pageNum+ " 页 :" );
            for (int j=0;j<a.length;j++){
                DmTltpdf tltpdf=new DmTltpdf();
                tltpdf.setDcCh(dcCh);
                tltpdf.setTh(th);
                tltpdf.setPageNum(i +"/"+pageNum);
                tltpdf.setRows((j+1) +"/"+a.length);
                tltpdf.setContent(a[j]);
                list.add(tltpdf);
//                System.out.println("第 " + (j+1) +"/"+a.length+ " 行 :");
//                System.out.println(a[j]);
            }
        }
        tltpdfService.saveBatch(list);
        document.close();
        return new ResultBean();
    }
    @PostMapping("/getListBom")
        public ResultBean getListBom(HttpServletRequest req, @RequestBody Map map) throws CustomException {
            List<BomVO> listBom = dmBomService.getListBom(req,map);

//        String id = syService.f_getpjh("DM", "SYSTEM", "BCHX");
//        String id1= syService.f_getpjh("DM", "SYSTEM", "CLDE");
//        System.out.println("id = " + id);
//        System.out.println("id = " + id1);
//            return  new ResultBean(listBom);
            return  new ResultBean(listBom);
        }
    @PostMapping("/getListBomRealy")
    public ResultBean getListBomRealy(HttpServletRequest req, @RequestBody Map map) throws CustomException {
        List<DmBom> listBom = dmBomService.getListBomRealy(req,map);
        return  new ResultBean(listBom);
    }
    @PostMapping("/getListBomRealy1")
    public ResultBean getListBomRealy1(HttpServletRequest req, @RequestBody Map map) throws CustomException {
        List<DmBom> list1 = dmBomService.list(new QueryWrapper<DmBom>().eq("dcch", map.get("mbch")));
        List<String> idds = list1.stream().filter(f -> StringUtils.isNotBlank(f.getYidd())).map(DmBom::getYidd).collect(Collectors.toList());
        List<DmBom> list = dmBomService.list(new QueryWrapper<DmBom>().eq("dcch", map.get("dcch"))
            .eq(StrUtil.isNotEmpty((String) map.get("fd")), "fd", map.get("dcfd"))
            .eq(StrUtil.isNotEmpty((String) map.get("dcpl")), "pl", map.get("dcpl"))
            .eq(StrUtil.isNotEmpty((String) map.get("zt")), "zt", map.get("zt"))
                .notIn(idds.size()>0,"idd",idds)
            .orderBy(true,true,"pl","fd","type","tzbh","ljbh")
        );
        return  new ResultBean(list);
    }

    @PostMapping("/addListBom")
    @AuthFunction
    public ResultBean addListBom(HttpServletRequest req, @RequestBody Map map) throws CustomException {
        List<BomVO> dmBoms = bomUploadService.insertBom(req,(String) map.get("dcch"), (String) map.get("dcpl"),"02");
//       dmBomService.insertBoms(dmBoms);
        return  new ResultBean(dmBoms);
    }


    @PostMapping("/saveListBom")
    public ResultBean saveListBom(HttpServletRequest req, @RequestBody List<BomVO> list) throws CustomException {
        bomUploadService.saveBom(req,list,"","",null);
//
        return  new ResultBean();
//        return null;
    }


    @PostMapping("/copyListBom")
    public ResultBean copyListBom(HttpServletRequest req, @RequestBody Map  map) throws CustomException {
        dmBomService.copyListBom(req,map);
//
        return  new ResultBean();
//        return null;
    }

}

